<!--
~ Copyright (c) 2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
~
~ WSO2 Inc. licenses this file to you under the Apache License,
~ Version 2.0 (the "License"); you may not use this file except
~ in compliance with the License.
~ You may obtain a copy of the License at
~
~ http://www.apache.org/licenses/LICENSE-2.0
~
~ Unless required by applicable law or agreed to in writing,
~ software distributed under the License is distributed on an
~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
~ KIND, either express or implied. See the License for the
~ specific language governing permissions and limitations
~ under the License.
-->
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.bpel.ui.clients.InstanceManagementServiceClient" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.PaginatedInstanceList" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.LimitedInstanceInfoType" %>
<%@ page import="org.apache.http.HttpStatus" %>
<%@ page import="org.wso2.carbon.bpel.ui.Constant" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.InstanceInfoType" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.InstanceStatus" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>

<%
    response.setHeader("Cache-Control",
            "no-store, max-age=0, no-cache, must-revalidate");
    // Set IE extended HTTP/1.1 no-cache headers.
    response.addHeader("Cache-Control", "post-check=0, pre-check=0");
    // Set standard HTTP/1.0 no-cache header.
    response.setHeader("Pragma", "no-cache");

    String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);

    InstanceManagementServiceClient client;
    InstanceInfoType instanceInfoReturned;

    client = new InstanceManagementServiceClient(cookie, backendServerURL, configContext);


    PaginatedInstanceList instanceList;
    int numberOfPages;
    String pageNumber = request.getParameter("pageNumber");
    if (pageNumber == null) {
        pageNumber = "0";
    }
    int pageNumberInt = 0;
    try {
        pageNumberInt = Integer.parseInt(pageNumber);
    } catch (NumberFormatException ignored) {

    }

    //Handling the "operation parameter"
    String iid = request.getParameter("iid");
    if (iid != null && iid.length() > 0) {
        instanceInfoReturned = client.getInstanceInfo(Long.parseLong(iid.trim()));

        String operation = request.getParameter("operation");
        if (operation != null) {
            if (operation.toLowerCase().equals("suspend")) {
                try {
                    instanceInfoReturned.setStatus(InstanceStatus.SUSPENDED);
                } catch (Exception e) {
                    response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
                    CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
%>
<script type="text/javascript">
    location.href = "../admin/error.jsp";
</script>
<%
                    return;
                }

            } else if (operation.toLowerCase().equals("resume")) {
                try {
                    instanceInfoReturned.setStatus(InstanceStatus.ACTIVE);
                } catch (Exception e) {
                    response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
                    CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
%>
<script type="text/javascript">
    location.href = "../admin/error.jsp";
</script>
<%
                    return;
                }

            } else if (operation.toLowerCase().equals("terminate")) {
                try {
                    instanceInfoReturned.setStatus(InstanceStatus.TERMINATED);
                } catch (Exception e) {
                    response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
                    CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
%>
<script type="text/javascript">
    location.href = "../admin/error.jsp";
</script>
<%
                    return;
                }

            }
        }
    }

    String instanceListFilter = request.getParameter("filter");
    if (instanceListFilter == null || instanceListFilter.length() == 0) {
        // Sending space to back-end. Workaround to handle multi-tenant case.
        // Decide to remove "name}}* namespace=*" filter used earlier to get all instances.
        instanceListFilter = " ";
    }

    String instanceListOrderBy = request.getParameter("order");
    if (instanceListOrderBy == null || instanceListOrderBy.length() == 0) {
        instanceListOrderBy = "-last-active";
    }

    String parameters = "filter=" + instanceListFilter + "&order=" + instanceListOrderBy;

    boolean isAuthenticatedForProcessManagement =
            CarbonUIUtil.isUserAuthorized(request, "/permission/admin/manage/bpel/processes");
    boolean isAuthenticatedForInstanceManagement =
            CarbonUIUtil.isUserAuthorized(request, "/permission/admin/manage/bpel/instances");
    try {
        //client = new InstanceManagementServiceClient(cookie, backendServerURL, configContext);
        instanceList = client.getPaginatedInstanceList(instanceListFilter, instanceListOrderBy,
                Constant.MAX_INSTANCES_TO_BE_FETCHED,
                pageNumberInt);
        if (instanceList != null) {
            numberOfPages = instanceList.getPages();
        } else {
            numberOfPages = 0;
        }
    } catch (Exception e) {
        response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
        CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
%>
<jsp:include page="../admin/error.jsp"/>
<%
        return;
    }
%>
<fmt:bundle basename="org.wso2.carbon.bpel.ui.i18n.Resources">
<carbon:breadcrumb
        label="bpel.instances"
        resourceBundle="org.wso2.carbon.bpel.ui.i18n.Resources"
        topPage="true"
        request="<%=request%>"/>
<div id="middle">
<link rel="stylesheet" type="text/css" href="css/instance_list.css" />
<script type="text/javascript" src="js/bpel-main.js"></script>
<script type="text/javascript" src="js/jquery.form.js"></script>
<script type="text/javascript">
var currentPage = <%=pageNumber%>;
var intObj;
var insAvailable = false;
BPEL.instance.loadInstanceList = function() {
    var listInstancesURL = "list_instances-ajaxprocessor.jsp";
    jQuery.ajax({
        url: listInstancesURL,
        dataType:'xml',
        type:'GET',
        error:function(xhr, textStatus, errorThrown) {
            if(textStatus != 'timeout'){
                if(intObj){
                    clearInterval(intObj);
                }
            }
        },
        success:BPEL.instance.fillInstanceList
    });
};

BPEL.instance.deleteInstance = function(iid) {
    function deleteYes() {
        jQuery.get("delete_instances-ajaxprocessor.jsp", {iid: iid}, function(data) {

            if (jQuery(data).find('ERRORDIALOG').length != 0) {
                CARBON.showErrorDialog(data);
            } else {
                CARBON.showInfoDialog(data);
            }
            BPEL.instance.loadInstanceList();
            clearInterval(intObj);
            intObj = setInterval("BPEL.instance.loadInstanceList()", 10000);

        }, "html");
    };
    CARBON.showConfirmationDialog('<fmt:message key="do.you.want.to.delete.instance"/> ' + iid + "?", deleteYes, null);
};

BPEL.instance.resumeInstance = function(iid) {
    function resumeYes() {
        window.location.href = "instance_list.jsp?operation=resume&iid=" + iid;
    }
    CARBON.showConfirmationDialog('<fmt:message key="do.you.want.to.suspend.instance"/> ' + iid + "?", resumeYes, null);
    return false;
};

BPEL.instance.suspendInstance = function(iid) {
    function suspendYes() {
        window.location.href = "instance_list.jsp?operation=suspend&iid=" + iid;
    }
    CARBON.showConfirmationDialog('<fmt:message key="do.you.want.to.suspend.instance"/> ' + iid + "?", suspendYes, null);
    return false;
};

BPEL.instance.terminateInstance = function(iid) {
    function terminateYes() {
        window.location.href = "instance_list.jsp?operation=terminate&iid=" + iid;
    }
    CARBON.showConfirmationDialog('<fmt:message key="do.you.want.to.suspend.instance"/> ' + iid + "?", terminateYes, null);
    return false;
};

BPEL.instance.initForm = function() {
    jQuery("#lastactive").datepicker({showOn: 'both', buttonImage: 'images/calendar.gif', buttonText: 'Choose Date',
        buttonImageOnly: true, onSelect: function(dateText, inst) {
                var lastActiveOption = jQuery("#instance_filter_form :radio[@name='ladateopt']").fieldValue()[0];
                if (!lastActiveOption) {
                     $("#instance_filter_form :radio[@name='ladateopt']").val(["onb"]);
                }
            }
        });
    jQuery("#date").datepicker({showOn: 'both', buttonImage: 'images/calendar.gif', buttonImageOnly: true,
        buttonText: 'Choose Date', onSelect: function(dateText, inst) {
                var dateOption = jQuery("#instance_filter_form :radio[@name='dateopt']").fieldValue()[0];
                if (!dateOption) {
                     $("#instance_filter_form :radio[@name='dateopt']").val(["onb"]);
                }
            }
        });

    BPEL.instance.fillFilter();

    jQuery("#instance_filter_form").submit(function() {
        var filter = "";
        var instanceOrder = "";
        var name;
        var namespace;
        var status;
        var started;
        var startedFilter;
        var order;
        var orderBy;
        var lastAct;
        var laFilter;
        var startedTime;
        var lastActiveTime;
        var version;

        version = $("#instance_filter_form :text[@name='version']").fieldValue()[0];
        name = $("#instance_filter_form :text[@name='name']").fieldValue()[0];
        namespace = $("#instance_filter_form :text[@name='namespace']").fieldValue()[0];
        if (BPEL.process.validateVersion(version)) {
            if (BPEL.process.validateName(name)) {
                if (BPEL.process.validateName(namespace)) {
                    started = $("#instance_filter_form :text[@name='sdate']").fieldValue()[0];
                    lastAct = $("#instance_filter_form :text[@name='lastact']").fieldValue()[0];
                    startedTime = $("#instance_filter_form :text[@name='startedtime']").fieldValue()[0];
                    lastActiveTime = $("#instance_filter_form :text[@name='lastactivetime']").fieldValue()[0];
                    if (BPEL.process.validateDate(started) && BPEL.process.validateDate(lastAct)) {
                        if (BPEL.process.validateTime(startedTime) && BPEL.process.validateTime(lastActiveTime)) {
                            status = $("#instance_filter_form :radio[@name='statgrp']").fieldValue()[0];
                            startedFilter = $("#instance_filter_form :radio[@name='dateopt']").fieldValue()[0];
                            order = $("#instance_filter_form :radio[@name='asdec']").fieldValue()[0];
                            orderBy = $("#orderbytype")[0].value;
                            laFilter =  $("#instance_filter_form :radio[@name='ladateopt']").fieldValue()[0];

                            if (status && (typeof status).toLowerCase() == 'string') {
                                if (status.toLowerCase() != 'all') {
                                    filter += "status=" + status.toLowerCase();
                                }
                            }

                            if (name && (typeof name).toLowerCase() == 'string') {
                                if ((name.indexOf('{') == 0 && name.indexOf('{') == 1) ||
                                    (name.indexOf('}') == 0 && name.indexOf('}') == 1)) {
                                    filter += " name" + name;
                                } else {
                                    filter += " name=" + name;
                                }
                            }

                            if (namespace && (typeof namespace).toLowerCase() == 'string' && namespace != '*') {
                                if (filter != "")
                                    filter += " namespace=" + namespace;
                                else
                                    filter += "namespace=" + namespace;
                            }

                            var d;

                            if (started && (typeof started).toLowerCase() == 'string') {
                                d = started.split("/");
                                if (!startedFilter) {
                                    filter += " started=" + d[2] + "-" + d[0] + "-" + d[1];
                                } else if (startedFilter.toLowerCase() == "onb") {
                                    filter += " started<=" + d[2] + "-" + d[0] + "-" + d[1];
                                } else if (startedFilter.toLowerCase() == "ona") {
                                    filter += " started>=" + d[2] + "-" + d[0] + "-" + d[1];
                                }

                                if(startedTime && (typeof startedTime).toLowerCase() == 'string' && startedTime.length > 0){
                                    filter += "T"+ startedTime;
                                }
                            }

                            if (lastAct && (typeof lastAct).toLowerCase() == 'string') {
                                d = lastAct.split("/");
                                if (!laFilter) {
                                    filter += " last-active=" + d[2] + "-" + d[0] + "-" + d[1];
                                } else if (laFilter.toLowerCase() == "onb") {
                                    filter += " last-active<=" + d[2] + "-" + d[0] + "-" + d[1];
                                } else if (laFilter.toLowerCase() == "ona") {
                                    filter += " last-active>=" + d[2] + "-" + d[0] + "-" + d[1];
                                }

                                if(lastActiveTime && (typeof lastActiveTime).toLowerCase() == 'string' && lastActiveTime.length > 0){
                                    filter += "T" + lastActiveTime;
                                }
                            }

                            if (version && (typeof version).toLowerCase() == 'string') {
                                if (filter != "")
                                    filter += " version=" + version;
                                else
                                    filter += "version=" + version;
                            }

                            if ((!status && !name && !namespace && !started && !lastAct && !version) ||
                                (filter.length == 0 && status.toLowerCase() == 'all')) {
                                filter = "name}}* namespace=*";
                            }

                            if (orderBy && (typeof orderBy).toLowerCase() == 'string') {
                                if (order && (typeof order).toLowerCase() == 'string' && order.toLowerCase() == 'ascending') {
                                    instanceOrder = "+" + orderBy.toLowerCase();
                                } else if (order && (typeof order).toLowerCase() == 'string' && order.toLowerCase() == 'descending') {
                                    instanceOrder = "-" + orderBy.toLowerCase();
                                }
                            } else {
                                instanceOrder = "-started";
                            }

                            window.location.href = "instance_list.jsp?filter=" + encodeURIComponent(filter) + "&order=" + encodeURIComponent(instanceOrder)
                                    + "&clearpage=yes";
                        } else {
                            CARBON.showErrorDialog("<p><fmt:message key="enter.valide.time"/></p>");
                        }
                    } else {
                        CARBON.showErrorDialog("<p><fmt:message key="enter.valide.date"/></p>");
                    }
                } else {
                    CARBON.showErrorDialog("<p><fmt:message key="enter.valide.namespace"/></p>");
                }
            } else {
                CARBON.showErrorDialog("<p><fmt:message key="enter.valide.name"/></p>");
            }
        } else {
            CARBON.showErrorDialog("<p><fmt:message key="enter.valide.version"/></p>");
        }
        return false;
    });

    jQuery('#resetInstanceFilter').click(function() {
        window.location.href = "instance_list.jsp?filter=" + encodeURIComponent("name}}* namespace=*") + "&order=" + encodeURIComponent("-last-active")
                + "&clearpage=yes";
        return false;
    });
};

    BPEL.process.validateDate = function(datestr) {
        if (datestr == '')
            return true;

        var matches = datestr.match(/^((([0][13578]|[1][02])\/([012][\d]|[3][01]))|(([0][469]|[1][1])\/([012][\d]|[3][0]))|([0][2]\/([01][\d]|[2][0123456789])))\/[\d]{4}$/);

        if (matches) {
            return true;
        }
        return false;
    };

    BPEL.process.validateTime = function(timestr) {
        if (timestr == '')
            return true;

        var matches = timestr.match(/^([01]\d|[2][0123])\:[012345]\d\:[012345]\d$/);

        if (matches) {
            return true;
        }
        return false;
    };

BPEL.process.validateVersion = function(version) {
     if (version == '') {
         return true;
     } else if (version == '0') {
         return false;
     }
     var matches = version.match(/^\d*$/);
     if (matches) {
        return true;
     }
     return false;
};

BPEL.process.validateName = function(str) {
     return (str.indexOf("'") < 0 && str.indexOf("=") < 0 && str.indexOf("<") < 0 && str.indexOf(">") < 0);
};

BPEL.instance.fillFilter = function() {
    var status = '<%=instanceListFilter%>';
    var orderby = '<%=instanceListOrderBy%>';
    var name;
    var namespace;
    var dateOpt;
    var params;
    var statgrp = "All";
    var started;
    var order;
    var lastAct;
    var laFilter;
    var startedTime;
    var lastActiveTime;
    var temp;
    var version;

    params = status.split(" ");
    for(i = 0; i < params.length; i++) {
        var param = params[i].split("=");
        switch(param[0]) {
        case "status":
          statgrp = param[1];
          break;
        case "name":
          name = param[1];
          break;
        case "version":
          version = param[1];
          break;
        case "namespace":
          namespace = param[1];
          break;
        case "started>":
	      temp = param[1].split("T");
          started = temp[0];
	      startedTime = temp[1];
          dateOpt =  "ona";
          break;
        case "started<":
	      temp = param[1].split("T");
          started = temp[0];
	      startedTime = temp[1];
          dateOpt = "onb";
          break;
        case "started":
	      temp = param[1].split("T");
          started = temp[0];
	      startedTime = temp[1];
          dateOpt = false;
          break;
        case "last-active>":
	      temp = param[1].split("T");
          lastAct = temp[0];
	      lastActiveTime = temp[1];
          laFilter =  "ona";
          break;
        case "last-active<":
	      temp = param[1].split("T");
          lastAct = temp[0];
	      lastActiveTime = temp[1];
          laFilter = "onb";
          break;
        case "last-active":
	      temp = param[1].split("T");
          lastAct = temp[0];
	      lastActiveTime = temp[1];
          laFilter = false;
          break;
        }
    }

    var d;

    if (started && (typeof started).toLowerCase() == 'string' && started.indexOf("-") != -1) {
        d = started.split("-");
        started = d[1] + "/" + d[2] + "/" + d[0];
    }

    if (lastAct && (typeof lastAct).toLowerCase() == 'string' && lastAct.indexOf("-") != -1) {
        d = lastAct.split("-");
        lastAct = d[1] + "/" + d[2] + "/" + d[0];
    }

    if (orderby.indexOf("-") == 0) {
        order = "Descending";
	    orderby = orderby.substring(1);
    } else if (orderby.length != 0) {
        order = "Ascending";
	    orderby = orderby.substring(1);
    } else {
        order = "";
	    orderby = "";
    }

    $("#instance_filter_form :text[@name='name']").val(name);
    $("#instance_filter_form :text[@name='namespace']").val(namespace);
    $("#instance_filter_form :text[@name='version']").val(version);
    $("#instance_filter_form :radio[@name='statgrp']").val([statgrp]);
    $("#instance_filter_form :radio[@name='dateopt']").val([dateOpt]);
    $("#instance_filter_form :text[@name='sdate']").val(started);
    $("#instance_filter_form :radio[@name='asdec']").val([order]);
    $("#orderbytype").val(orderby);
    $("#instance_filter_form :text[@name='lastact']").val(lastAct);
    $("#instance_filter_form :radio[@name='ladateopt']").val([laFilter]);
    $("#instance_filter_form :text[@name='startedtime']").val(startedTime);
    $("#instance_filter_form :text[@name='lastactivetime']").val(lastActiveTime);
};

BPEL.instance.initDelete = function() {
    jQuery("#deleteInstances").click(function() {
        function handleYes() {
            var filterVal = jQuery('input[@name=filterval]').fieldValue();
            jQuery.get("delete_instances-ajaxprocessor.jsp", {filter: filterVal}, function(data) {

                if (jQuery(data).find('ERRORDIALOG').length != 0) {
                    CARBON.showErrorDialog(data);
                } else {
                    CARBON.showInfoDialog(data);
                }
                //CARBON.showInfoDialog(data);
                BPEL.instance.loadInstanceList();
                clearInterval(intObj);
                intObj = setInterval("BPEL.instance.loadInstanceList()", 10000);

            }, "html");
            jQuery('input[@name=filterval]').clearFields();
        }

        if (insAvailable) {
            var divStr = "<div style='margin:20px;'><p><fmt:message key="instance.filter"/></p><br/><input type='text' id='ifilter' size='40' name='filterval'><br/>" +
                         "<p style='color:red;'><fmt:message key="all.the.matched.instances.will.be.deleted.from.the.system"/></p></div>";

            var strDialog = "<div id='dialog' title='WSO2 Carbon' class='flora'>" +
                            divStr + "</div>";

            jQuery("#dcontainer").html(strDialog);
            jQuery("#dialog").dialog({
                height:170,
                width:380,
                modal:true,
                close:function() {
                    jQuery(this).dialog('destroy').remove();
                    jQuery("#dcontainer").empty();
                    return false;
                },
                buttons:{
                    "<fmt:message key="button.yes"/>":function() {
                        handleYes();
                        jQuery(this).dialog("destroy").remove();
                        jQuery("#dcontainer").empty();
                        return false;
                    },
                    "<fmt:message key="button.no"/> ":function() {
                        jQuery(this).dialog("destroy").remove();
                        jQuery("#dcontainer").empty();
                        return false;
                    }
                }
            });
            return false;
        } else {
            CARBON.showInfoDialog("<fmt:message key="currently.there.are.no.instances"/>");
            return false;
        }
    });
};

BPEL.instance.deleteIns = function(iid) {
    function handleYes() {
        var filterVal = "iid=" + iid;
        jQuery.get("delete_instances-ajaxprocessor.jsp", {filter: filterVal}, function(data) {
            CARBON.showInfoDialog(data);
            BPEL.instance.loadInstanceList();
            clearInterval(intObj);
            intObj = setInterval("BPEL.instance.loadInstanceList()", 10000);

        });
    }
    CARBON.showConfirmationDialog("<fmt:message key="do.you.want.to.delete.the.instance"/> "+ iid + "?", handleYes, null);
    return false;
};

 BPEL.instance.addSliding = function() {
        jQuery("#filterToggleBtn").click(function() {
            jQuery("#instanceListForm").slideToggle("normal");
            jQuery(this).toggleClass("active");
            return false;
        });
    };

BPEL.instance.loading = function() {
    $("#loading").bind("ajaxStart", function() {
        var tOffset = $("#instance-list").offset();
        var tWidth = $("#instance-list").width();
        $("#load-image").attr("src", "images/loader.gif");
        var iWidth = $("#load-image").width();
        var loadLeft = parseInt(tOffset.left) + (parseInt(tWidth) - parseInt(iWidth))/2;
        $("#loading").css("top", tOffset.top).css("left", loadLeft);
        $(this).css("display", "block");
     }).bind("ajaxStop", function(){
        $(this).css("display", "none");
     });
};

BPEL.instance.colourLink = function(filter) {
    //only the selected link is coloured and others are not re-set, because the request loads the whole new page
    //so that previously coloured links are no longer exist.
    switch (filter) {
        case "name}}* namespace=*":
            $("#linkall").css("color","black");
            $("#resetInstanceFilter").css("display", "none");
            break;
        case "status=completed":
            $("#linkcompleted").css("color","black");
            break;
        case "status=active":
            $("#linkactive").css("color","black");
            break;
        case "status=terminated":
            $("#linkterminated").css("color","black");
            break;
        case "status=failed":
            $("#linkfailed").css("color","black");
            break;
        case "status=suspended":
            $("#linksuspended").css("color","black");
            break;
        case "status=error":
            $("#linkerror").css("color","black");
            break;
    }
};

jQuery(document).ready(function() {
    BPEL.instance.loading();
    BPEL.instance.loadInstanceList();
    BPEL.instance.initForm();
    BPEL.instance.addSliding();
    BPEL.instance.colourLink('<%=instanceListFilter%>');
    intObj = setInterval("BPEL.instance.loadInstanceList()", 60000);
});
</script>
    <div id="instance-list-main">
        <h2><fmt:message key="instaces.created"/></h2>

        <div id="workArea">
            <div id="instanceListOps">
                <p>&nbsp;</p>
                <table class="normal">
                    <tr>
                        <td>
                            <fmt:message key="show.instances"/>: &nbsp;
                        </td>
                        <td>
                            <a id="linkall" href="instance_list.jsp?filter=name}}*%20namespace%3D*&order=%2dlast-active&clearpage=yes"><fmt:message key="all"/></a>&nbsp;<b>|</b>&nbsp;
                        </td>
                        <td><a id="linkactive" href="instance_list.jsp?filter=status%3Dactive&order=%2dlast-active&clearpage=yes"><fmt:message key="active"/></a>&nbsp;<b>|</b>&nbsp;</td>
                        <td><a id="linkcompleted"
                               href="instance_list.jsp?filter=status%3Dcompleted&order=%2dlast-active&clearpage=yes"><fmt:message
                                key="completed"/></a>&nbsp;<b>|</b>&nbsp;</td>
                        <td><a id="linksuspended"
                               href="instance_list.jsp?filter=status%3Dsuspended&order=%2dlast-active&clearpage=yes"><fmt:message
                                key="suspended"/></a>&nbsp;<b>|</b>&nbsp;</td>
                        <td><a id="linkterminated"
                               href="instance_list.jsp?filter=status%3Dterminated&order=%2dlast-active&clearpage=yes"><fmt:message
                                key="terminated"/></a>&nbsp;<b>|</b>&nbsp;</td>
                        <td><a id="linkerror"
                               href="instance_list.jsp?filter=status%3Derror&order=%2dlast-active&clearpage=yes"><fmt:message
                                key="error"/></a>&nbsp;<b>|</b>&nbsp;</td>
                        <td><a id="linkfailed"
                               href="instance_list.jsp?filter=status%3Dfailed&order=%2dlast-active&clearpage=yes"><fmt:message
                                key="failed"/></a>&nbsp;</td>

                    </tr>
                </table>
                <p>&nbsp;</p>
            </div>

            <table>
                <tbody>
                <tr>
                    <td><a href="#" id="filterToggleBtn" class="slide-btn"><fmt:message
                            key="advance.filter"/></a></td>
                    <td><a href="#" id="resetInstanceFilter" class="icon-link"
                           style="background-image:url(images/reset.gif)"><fmt:message
                            key="reset.filter"/></a></td>
                    <td id="deleteInstancetd"></td>
                </tr>
                </tbody>
            </table>

            <div id="instanceListForm">
                <form action="GET" class="instance_filter" id="instance_filter_form" target="_self">
                    <table class="styledLeft" width="100%">
                        <thead>
                        <tr>
                            <th><fmt:message key="narrow.down.the.list"/>
                            </th>
                        </tr>
                        </thead>

                        <tbody>
                        <tr>
                            <td>
                                <table class="normal">
                                    <tr>
                                        <td><fmt:message key="name"/></td>
                                        <td>
                                            <input type="text" size="42" name="name">
                                        </td>
                                    </tr>
                                    <tr>
                                        <td><fmt:message key="namespace"/></td>
                                        <td>
                                            <input type="text" size="42" name="namespace">
                                        </td>
                                    </tr>
                                    <tr>
                                        <td><fmt:message key="version"/>:
                                        </td>
                                        <td>
                                            <input type="text" size="10" name="version">
                                        </td>
                                    </tr>
                                    <tr>
                                        <td><fmt:message key="status"/></td>
                                        <td>
                                            <input type="radio" name="statgrp" value="All"
                                                   checked><fmt:message key="all"/>
                                            <input type="radio" name="statgrp"
                                                   value="active"><fmt:message key="active"/>
                                            <input type="radio" name="statgrp"
                                                   value="completed"><fmt:message
                                                key="completed"/>
                                            <input type="radio" name="statgrp"
                                                   value="suspended"><fmt:message
                                                key="suspended"/>
                                            <input type="radio" name="statgrp"
                                                   value="terminated"><fmt:message
                                                key="terminated"/>
                                            <input type="radio" name="statgrp"
                                                   value="error"><fmt:message key="error"/>
                                            <input type="radio" name="statgrp"
                                                   value="failed"><fmt:message key="failed"/>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td>
                                            <fmt:message key="started"/>
                                        </td>
                                        <td>
                                            <input type="radio" name="dateopt" value="onb"> <fmt:message
                                                key="on.or.before"/>
                                            <input type="radio" name="dateopt" value="ona"> <fmt:message
                                                key="on.or.after"/>
                                            <input type="text" id="date" size="15" name="sdate">
                                            <input type="text" id="startedtimeid" size="10"
                                                   name="startedtime"><span class="icon-field"
                                                                            style="background-image:url(images/clock.gif)"></span>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td><fmt:message key="last.active1"/></td>
                                        <td>
                                            <input type="radio" name="ladateopt" value="onb">
                                            <fmt:message
                                                    key="on.or.before"/>
                                            <input type="radio" name="ladateopt" value="ona">
                                            <fmt:message key="on.or.after"/>
                                            <input type="text" size="15" name="lastact" id="lastactive">
                                            <input type="text" id="lastactivetimeid" size="10"
                                                   name="lastactivetime"><span class="icon-field"
                                                                               style="background-image:url(images/clock.gif)"></span>
                                        </td>
                                    </tr>
                                    <tr>
                                        <td><fmt:message key="order.by"/></td>
                                        <td>
                                            <input type="radio" name="asdec" value="Ascending"
                                                   checked><fmt:message
                                                key="ascending"/>
                                            <input type="radio" name="asdec" value="Descending" checked><fmt:message
                                                key="descending"/>
                                            <select id="orderbytype" name="orderby">
                                                <option value="pid"><fmt:message key="iid"/></option>
                                                <option value="name"><fmt:message key="pid"/></option>
                                                <option value="version"><fmt:message
                                                        key="version"/></option>
                                                <option value="status"><fmt:message
                                                        key="status"/></option>
                                                <option value="started"><fmt:message
                                                        key="started.date"/></option>
                                                <option value="last-active"><fmt:message
                                                        key="last.active"/></option>
                                            </select>
                                        </td>
                                    </tr>

                                </table>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <input type="submit" class="button" value="<fmt:message key="filter"/>">
                                <input type="reset" class="button" value="<fmt:message key="clear"/>">
                            </td>
                        </tr>
                        </tbody>

                    </table>

                </form>

            </div>
            <div id="instanceListFilters"></div>
            <div id="instanceListPagesUp"></div>
            <p>&nbsp;</p>

            <div id="instance-list">
<%
    if (instanceList != null && instanceList.getInstance() != null) {
%>
                <carbon:paginator pageNumber="<%=pageNumberInt%>" numberOfPages="<%=numberOfPages%>"
                                  page="instance_list.jsp" pageNumberParameterName="pageNumber"
                                  resourceBundle="org.wso2.carbon.bpel.ui.i18n.Resources"
                                  prevKey="prev" nextKey="next"
                                  parameters="<%= parameters%>"/>
                <table id="instanceListTable" class="styledLeft" width="100%">
                    <thead>
                    <tr>
                        <th>
                            <nobr><fmt:message key="instance.id"/></nobr>
                        </th>
                        <th>
                            <nobr><fmt:message key="process.id"/></nobr>
                        </th>
                        <th>
                            <nobr><fmt:message key="status"/></nobr>
                        </th>
                        <th>
                            <nobr><fmt:message key="date.started"/></nobr>
                        </th>
                        <th>
                            <nobr><fmt:message key="last.active"/></nobr>
                        </th>
<%
    if (isAuthenticatedForInstanceManagement) {
%>
                        <th colspan="3"><fmt:message key="actions"/></th>
<%
    }
%>
                    </tr>
                    </thead>
                    <tbody>
<%
    for (LimitedInstanceInfoType instanceInfo : instanceList.getInstance()) {
%>
                    <tr>
<%
        if (isAuthenticatedForInstanceManagement) {
%>
                        <td>
                            <a href="instance_view.jsp?iid=<%=instanceInfo.getIid()%>"><%=instanceInfo.getIid()%>
                            </a></td>
<%
        } else {
%>
                        <td><%=instanceInfo.getIid()%>
                        </td>
<%
        }

        if (isAuthenticatedForProcessManagement) {
%>
                        <td>
                            <a href="process_info.jsp?Pid=<%=instanceInfo.getPid()%>"><%=instanceInfo.getPid()%>
                            </a></td>
<%
        } else {
%>
                        <td><%=instanceInfo.getPid()%>
                        </td>
<%
        }
%>
                        <td><%=instanceInfo.getStatus()%>
                        </td>
                        <td><%=instanceInfo.getDateStarted().getTime().toString()%>
                        </td>
                        <td><%=instanceInfo.getDateLastActive().getTime().toString()%>
                        </td>
<%
        if (isAuthenticatedForInstanceManagement) {
%>
                        <td id="operations">

<%
            if (instanceInfo.getStatus().getValue().toUpperCase().equals("ACTIVE")) {
%>
                            <script type="text/javascript">
                                var ops = "<a href='#' class='icon-link' style='background-image:url(images/suspend.gif);' onclick='suspendInstance('"
                                        + <%=instanceInfo.getIid()%> + "')'><fmt:message key="suspend"/></a></td><td  style='border-right:0px;border-left:0px;'>" +
                                          "<a href='#' class='icon-link' style='background-image:url(images/terminate.gif);' onclick='terminateInstance('"
                                        + <%=instanceInfo.getIid()%> + "')'><fmt:message key="terminate"/></a></td><td  style='border-left:0px;'>" +
                                          "<a href='#' class='icon-link' style='background-image:url(../admin/images/delete.gif);' onclick='deleteInstance('"
                                        + <%=instanceInfo.getIid()%> + "')'><fmt:message key="delete"/></a></td></tr>";
                                jQuery("#operations").html(ops);
                            </script>
<%
            } else if (instanceInfo.getStatus().getValue().toUpperCase().equals("COMPLETED") || instanceInfo.getStatus().getValue().toUpperCase().equals("ERROR") || instanceInfo.getStatus().getValue().toUpperCase().equals("FAILED")) {
%>
                            <script type="text/javascript">
                                var ops = "<a href='#' class='icon-link' style='background-image:url(../admin/images/delete.gif);' onclick='BPEL.instance.deleteInstance("
                                        + <%=instanceInfo.getIid()%> + ")'><fmt:message key="delete"/></a>" +
                                          "</td><td  style='border-right:0px;border-left:0px;'></td><td  style='border-left:0px;'>" +
                                          "</td></tr>";
                                jQuery("#operations").html(ops);
                            </script>
<%
            } else if (instanceInfo.getStatus().getValue().toUpperCase().equals("TERMINATED")) {
%>
                            <script type="text/javascript">
                                var ops = "<a href='#' class='icon-link' style='background-image:url(../admin/images/delete.gif);' onclick='deleteInstance('"
                                        + <%=instanceInfo.getIid()%> + "')'><fmt:message key="delete"/></a>" +
                                          "</td><td  style='border-right:0px;border-left:0px;'></td><td  style='border-left:0px;'>" +
                                          "</td></tr>";
                                jQuery("#operations").html(ops);
                            </script>
<%
            } else if (instanceInfo.getStatus().getValue().toUpperCase().equals("SUSPENDED")) {
%>
                            <script type="text/javascript">
                                var ops = "<a href='#' class='icon-link' style='background-image:url(images/resume.gif);' onclick='resumeInstance('"
                                        + <%=instanceInfo.getIid()%> + "')'><fmt:message key="resume"/></a></td><td  style='border-right:0px;border-left:0px;'>" +
                                          "<a href='#' class='icon-link' style='background-image:url(images/terminate.gif);' onclick='terminateInstance('"
                                        + <%=instanceInfo.getIid()%> + "')'><fmt:message key="terminate"/></a></td>" +
                                          "<td  style='border-left:0px'><a href='#' class='icon-link' style='background-image:url(../admin/images/delete.gif);' onclick='deleteInstance('"
                                        + <%=instanceInfo.getIid()%> + "')'><fmt:message key="delete"/></a></td></tr>";
                                jQuery("#operations").html(ops);
                            </script>
<%
            }
%>
                        </td>
<%
        }
%>
                    </tr>
<%
    }
%>
                    </tbody>
                </table>
                <carbon:paginator pageNumber="<%=pageNumberInt%>" numberOfPages="<%=numberOfPages%>"
                                  page="instance_list.jsp" pageNumberParameterName="pageNumber"
                                  resourceBundle="org.wso2.carbon.bpel.ui.i18n.Resources"
                                  prevKey="prev" nextKey="next"
                                  parameters="<%= parameters%>"/>
<%
    } else {
%>
                <p><fmt:message key="bpel.process.instances.not.found"/></p>
<%
    }
%>
            </div>
            <div id="loading">
                <img id="load-image"/>
            </div>
            <p>&nbsp;</p>

            <div id="instanceListPagesDown"></div>
        </div>
    </div>
</div>
</fmt:bundle>