<!--
 ~ Copyright (c) 2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 ~
 ~ WSO2 Inc. licenses this file to you under the Apache License,
 ~ Version 2.0 (the "License"); you may not use this file except
 ~ in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~    http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing,
 ~ software distributed under the License is distributed on an
 ~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 ~ KIND, either express or implied.  See the License for the
 ~ specific language governing permissions and limitations
 ~ under the License.
 -->
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.bpel.ui.clients.InstanceManagementServiceClient" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.PaginatedInstanceList" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.LimitedInstanceInfoType" %>
<%@ page import="org.wso2.carbon.bpel.ui.BpelUIUtil" %>
<%@ page import="org.wso2.carbon.bpel.ui.clients.ProcessManagementServiceClient" %>
<%@ page import="org.wso2.carbon.bpel.ui.InstanceFilterUtil" %>
<%@ page import="org.apache.commons.httpclient.HttpStatus" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>

<jsp:useBean id="instanceFilter" scope="session" class="org.wso2.carbon.bpel.ui.InstanceFilter"/>
<jsp:setProperty name="instanceFilter" property="*" />

<%
    response.setHeader("Cache-Control",
            "no-store, max-age=0, no-cache, must-revalidate");
    // Set IE extended HTTP/1.1 no-cache headers.
    response.addHeader("Cache-Control", "post-check=0, pre-check=0");
    // Set standard HTTP/1.0 no-cache header.
    response.setHeader("Pragma", "no-cache");

    String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String)session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);

    InstanceManagementServiceClient client;
    ProcessManagementServiceClient processManagementClient;
    PaginatedInstanceList instanceList;
    int numberOfPages;
    String processIds[];
    String advanceFilter;
    String advanceOrderBy;
    String operation = request.getParameter("operation");

    try{
        client = new InstanceManagementServiceClient(cookie, backendServerURL, configContext);
        processManagementClient = new ProcessManagementServiceClient(cookie, backendServerURL, configContext);
    } catch (Exception e) {
        response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
        CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
        session.setAttribute(CarbonUIMessage.ID, uiMsg);
%>
<jsp:include page="../admin/error.jsp"/>
<%
        return;
    }

    if(operation != null) {
        String iid = request.getParameter("iid");
        //BpelUIUtil.logInfo("Instance ID: " + iid, null);
        if(iid != null && !operation.equals("reset")) {
            Long instanceId = Long.parseLong(iid.trim());
            if(operation.trim().equals("suspend")) {
                try{
                    client.suspendInstance(instanceId);
                } catch(Exception e) {
                    response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
                    CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
                    session.setAttribute(CarbonUIMessage.ID, uiMsg);
%>
<jsp:include page="../admin/error.jsp"/>
<%
                    return;
                }
            } else if(operation.trim().equals("resume")) {
                try{
                    client.resumeInstance(instanceId);
                } catch(Exception e) {
                    response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
                    CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
                    session.setAttribute(CarbonUIMessage.ID, uiMsg);
%>
<jsp:include page="../admin/error.jsp"/>
<%
                    return;
                }
            } else if(operation.trim().equals("delete")) {
                try{
                    client.deleteInstance(instanceId);
                } catch(Exception e) {
                    response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
                    CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
                    session.setAttribute(CarbonUIMessage.ID, uiMsg);
%>
<jsp:include page="../admin/error.jsp"/>
<%
                    return;
                }
            } else if(operation.trim().equals("terminate")) {
                try{
                    client.terminateInstance(instanceId);
                } catch(Exception e) {
                    response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
                    CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
                    session.setAttribute(CarbonUIMessage.ID, uiMsg);
%>
<jsp:include page="../admin/error.jsp"/>
<%
                    return;
                }
            }
        } else {
            if(operation.equals("reset")){
                session.removeAttribute("instanceFilter");
            } else {
                BpelUIUtil.logWarn("Instance Id is null for operation " + operation + ".", null);
            }
        }
    }

    String pageNumber = request.getParameter("pageNumber");
    if(pageNumber == null){
        pageNumber = "0";
    }
    int pageNumberInt = 0;
    try{
        pageNumberInt = Integer.parseInt(pageNumber);
    } catch (NumberFormatException ignored){

    }

    if(instanceFilter != null) {
        advanceFilter = InstanceFilterUtil.createInstanceFilterStringFromFormData(instanceFilter);
        advanceOrderBy = InstanceFilterUtil.getOrderByFromFormData(instanceFilter);
    } else {
        // Sending space to back-end. Workaround to handle multi-tenant case.
        // Decide to remove "name}}* namespace=*" filter used earlier to get all instances.
        advanceFilter = " ";
        advanceOrderBy = "-last-active";
    }

    // When handling instance filter, we give the priority to filter URL parameter. If the filter URL
    // parameter is null we use the advance parameter. Also for the order-by filed we give the priority to
    // URL parameter.
    String instanceListFilter = request.getParameter("filter");
    if(instanceListFilter == null || instanceListFilter.length() == 0){
        instanceListFilter = advanceFilter;
    }

    // TODO: Add instance filter saving support(only for the session)
    String instanceListOrderBy = request.getParameter("order");
    if(instanceListOrderBy == null || instanceListOrderBy.length() == 0){
        instanceListOrderBy = advanceOrderBy;
    }

    String parameters = "filter=" + instanceListFilter + "&order=" + instanceListOrderBy;

    boolean isAuthenticatedForProcessManagement =
            CarbonUIUtil.isUserAuthorized(request, "/permission/admin/manage/bpel/instances");
    boolean isAuthenticatedForInstanceManagement =
            CarbonUIUtil.isUserAuthorized(request, "/permission/admin/manage/bpel/instances");

    String resetFilterLink = "list_instances.jsp?pageNumber=" + pageNumber + "&operation=reset";
    String activeInstancesFilterLink = "list_instances.jsp?pageNumber=" + pageNumber + "&filter=status%3Dactive&order=%2dlast-active";
    String completedInstanceFilterLink = "list_instances.jsp?pageNumber=" + pageNumber + "&filter=status%3Dcompleted&order=%2dlast-active";
    String suspendedInstanceFilterLink = "list_instances.jsp?pageNumber=" + pageNumber + "&filter=status%3Dsuspended&order=%2dlast-active";
    String terminatedInstanceFilterLink = "list_instances.jsp?pageNumber=" + pageNumber + "&filter=status%3Dterminated&order=%2dlast-active";
    String failedInstanceFilterLink = "list_instances.jsp?pageNumber=" + pageNumber + "&filter=status%3Dfailed&order=%2dlast-active";
    String errorInstanceFilterLink = "list_instances.jsp?pageNumber=" + pageNumber + "&filter=status%3Derror&order=%2dlast-active";


    try{
        processIds = processManagementClient.getAllProcesses();
    } catch (Exception e) {
        response.setStatus(500);
        CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
        session.setAttribute(CarbonUIMessage.ID, uiMsg);
%>
<jsp:include page="../admin/error.jsp"/>
<%
        return;
    }

    try{
        instanceList = client.getPaginatedInstanceList(instanceListFilter, instanceListOrderBy, 200, pageNumberInt);
        numberOfPages = instanceList.getPages();
    } catch (Exception e) {
        response.setStatus(500);
        CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
        session.setAttribute(CarbonUIMessage.ID, uiMsg);
%>
<jsp:include page="../admin/error.jsp"/>
<%
        return;
    }
%>
<fmt:bundle basename="org.wso2.carbon.bpel.ui.i18n.Resources">
    <carbon:breadcrumb
            label="bpel.instances"
            resourceBundle="org.wso2.carbon.bpel.ui.i18n.Resources"
            topPage="true"
            request="<%=request%>"/>
    <div id="middle">
        <script type="text/javascript" src="js/dyndatetime/jquery.dynDateTime.min.js"></script>
        <script type="text/javascript"  src="js/dyndatetime/lang/calendar-en.min.js"></script>
        <link rel="stylesheet" type="text/css" href="js/dyndatetime/css/calendar-blue.css" />
        <div id="instance-list-main">
            <h2><fmt:message key="instaces.created"/></h2>
            <div id="workArea">
                <div id="instance-list">
                    <table class="styledLeft" width="100%">
                        <form method="POST" target="_self" action="">
                            <thead>
                                <tr>
                                    <th>
                                        <table class="normal" style="padding: 0px;">
                                            <tbody>
                                                <tr>
                                                    <td style="border-right: 1px solid #CCCCCC;">
                                                        <a id="advance_instance_filter_toggle" href="#"><fmt:message key="advance.filter"/></a>
                                                    </td>
                                                    <td style="border-right: 1px solid #CCCCCC;">
                                                        <a href="<%=resetFilterLink%>"><fmt:message key="reset.filter"/></a>
                                                    </td>
                                                    <td style="border-right: 1px solid #CCCCCC;">
                                                        <a href="<%=activeInstancesFilterLink%>"><fmt:message key="active"/></a>
                                                    </td>
                                                    <td style="border-right: 1px solid #CCCCCC;">
                                                        <a href="<%=suspendedInstanceFilterLink%>"><fmt:message key="suspended"/></a>
                                                    </td>
                                                    <td style="border-right: 1px solid #CCCCCC;">
                                                        <a href="<%=completedInstanceFilterLink%>"><fmt:message key="completed"/></a>
                                                    </td>
                                                    <td style="border-right: 1px solid #CCCCCC;">
                                                        <a href="<%=terminatedInstanceFilterLink%>"><fmt:message key="terminated"/></a>
                                                    </td>
                                                     <td>
                                                        <a href="<%=errorInstanceFilterLink%>"><fmt:message key="error"/></a>
                                                    </td>
                                                    <td>
                                                        <a href="<%=failedInstanceFilterLink%>"><fmt:message key="failed"/></a>
                                                    </td>
                                                </tr>
                                            </tbody>
                                        </table>
                                    </th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>
                                        <table class="normal">
                                            <tbody>
                                                <tr>
                                                    <td>Process</td>
                                                    <td>
                                                        <select name="pid">
                                                            <option value="all" selected>All</option>
<%
        if(processIds != null && processIds.length > 0) {
            for(String pid : processIds) {
                if(instanceFilter != null && instanceFilter.getPid() != null && instanceFilter.getPid().equals(pid)) {
%>
                                                            <option value="<%=pid%>" selected><%=pid%></option>
<%
                } else {
%>
                                                            <option value="<%=pid%>"><%=pid%></option>
<%
                }
            }
        } else {
%>
                                                            <option value="noprocesses"><fmt:message key="no.processes"/></option>
<%
        }
%>
                                                        </select>
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td><fmt:message key="status"/></td>
<%
        if(instanceFilter != null) {
%>
                                                    <td>
                                                        <input type="checkbox" name="status" value="active" <%=instanceFilter.isActiveStatusSelected()%>>
                                                        <fmt:message key="active"/>
                                                        <input type="checkbox" name="status" value="completed" <%=instanceFilter.isComlpetedSelected()%>>
                                                        <fmt:message key="completed"/>
                                                        <input type="checkbox" name="status" value="suspended" <%=instanceFilter.isSuspendedSelected()%>>
                                                        <fmt:message key="suspended"/>
                                                        <input type="checkbox" name="status" value="terminated" <%=instanceFilter.isTerminatedSelected()%>>
                                                        <fmt:message key="terminated"/>
                                                        <input type="checkbox" name="status" value="error" <%=instanceFilter.isErrorSelected()%>>
                                                        <fmt:message key="error"/>
                                                        <input type="checkbox" name="status" value="failed" <%=instanceFilter.isFailedSelected()%>>
                                                        <fmt:message key="failed"/>
                                                    </td>
<%
        } else {
%>
                                                    <td>
                                                        <input type="checkbox" name="status" value="active">
                                                        <fmt:message key="active"/>
                                                        <input type="checkbox" name="status" value="completed">
                                                        <fmt:message key="completed"/>
                                                        <input type="checkbox" name="status" value="suspended">
                                                        <fmt:message key="suspended"/>
                                                        <input type="checkbox" name="status" value="terminated">
                                                        <fmt:message key="terminated"/>
                                                        <input type="checkbox" name="status" value="error">
                                                        <fmt:message key="error"/>
                                                        <input type="checkbox" name="status" value="failed">
                                                        <fmt:message key="failed"/>
                                                    </td>
<%
        }
%>
                                                </tr>
                                                <tr>
                                                    <td>
                                                        <fmt:message key="started"/>
                                                    </td>
                                                    <td>
<%
        if(instanceFilter != null) {
%>
                                                        <input type="radio" name="startedopt" value="onb" <%=instanceFilter.isStartedOnOrBeforeSelected()%>>
                                                        <fmt:message key="on.or.before"/>
                                                        <input type="radio" name="startedopt" value="ona" <%=instanceFilter.isStartedOnOrAfterSelected()%>>
                                                        <fmt:message key="on.or.after"/>
                                                        <input type="text" id="starteddate" size="20" name="starteddate" value="<%=instanceFilter.getStratedDate()%>">
                                                        <script type="text/javascript">
                                                            jQuery(document).ready(function() {
                                                                jQuery("#starteddate").dynDateTime({
                                                                    showsTime: true,
                                                                    ifFormat: "%Y-%m-%dT%H:%M"
                                                                });
                                                            });
                                                        </script>
<%
        } else {
%>
                                                        <input type="radio" name="startedopt" value="onb">
                                                        <fmt:message key="on.or.before"/>
                                                        <input type="radio" name="startedopt" value="ona">
                                                        <fmt:message key="on.or.after"/>
                                                        <input type="text" id="starteddate" size="20" name="starteddate">
                                                        <script type="text/javascript">
                                                            jQuery(document).ready(function() {
                                                                jQuery("#starteddate").dynDateTime({
                                                                    showsTime: true,
                                                                    ifFormat: "%Y-%m-%dT%H:%M"
                                                                });
                                                            });
                                                        </script>
<%
        }
%>
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td>
                                                        <fmt:message key="last.active1"/>
                                                    </td>
                                                    <td>
<%
        if(instanceFilter != null) {
%>
                                                        <input type="radio" name="ladateopt" value="onb" <%=instanceFilter.isLastActiveOnOrBeforeSelected()%>>
                                                        <fmt:message key="on.or.before"/>
                                                        <input type="radio" name="ladateopt" value="ona" <%=instanceFilter.isLastActiveOnOrAfterSelected()%>>
                                                        <fmt:message key="on.or.after"/>
                                                        <input type="text" id="ladate" size="20" name="ladate" value="<%=instanceFilter.getLastActiveDate()%>">
                                                        <script type="text/javascript">
                                                            jQuery(document).ready(function() {
                                                                jQuery("#ladate").dynDateTime({
                                                                    showsTime: true,
                                                                    ifFormat: "%Y-%m-%dT%H:%M"
                                                                });
                                                            });
                                                        </script>
<%
        } else {
%>
                                                        <input type="radio" name="ladateopt" value="onb">
                                                        <fmt:message key="on.or.before"/>
                                                        <input type="radio" name="ladateopt" value="ona">
                                                        <fmt:message key="on.or.after"/>
                                                        <input type="text" id="ladate" size="20" name="ladate">
                                                        <script type="text/javascript">
                                                            jQuery(document).ready(function() {
                                                                jQuery("#ladate").dynDateTime({
                                                                    showsTime: true,
                                                                    ifFormat: "%Y-%m-%dT%H:%M"
                                                                });
                                                            });
                                                        </script>
<%
        }
%>
                                                    </td>
                                                </tr>
                                            <tr>
                                                <td><fmt:message key="order.by"/></td>
                                                <td>
<%
        if(instanceFilter != null) {
%>
                                                    <input type="radio" name="asdec" value="Ascending" <%=instanceFilter.isOrderByAscendingSelected()%>>
                                                    <fmt:message key="ascending"/>
                                                    <input type="radio" name="asdec" value="Descending" <%=instanceFilter.isOrderByDescendingSelected()%>>
                                                    <fmt:message key="descending"/>
                                                    <select name="orderby">
                                                         <option value="pid" <%=instanceFilter.isOrderByPidSelected()%>>
                                                             <fmt:message key="pid"/>
                                                         </option>
                                                        <option value="status" <%=instanceFilter.isOrderByStatusSelected()%>>
                                                            <fmt:message key="status"/>
                                                        </option>
                                                        <option value="started" <%=instanceFilter.isOrderByStartedDateSelected()%>>
                                                            <fmt:message key="started.date"/>
                                                        </option>
                                                        <option value="last-active" <%=instanceFilter.isOrderByLastActiveDateSelected()%>>
                                                            <fmt:message key="last.active"/>
                                                        </option>
                                                    </select>
<%
        } else {
%>
                                                    <input type="radio" name="asdec" value="Ascending" checked>
                                                    <fmt:message key="ascending"/>
                                                    <input type="radio" name="asdec" value="Descending">
                                                    <fmt:message key="descending"/>
                                                    <select name="orderby">
                                                         <option value="pid">
                                                             <fmt:message key="pid"/>
                                                         </option>
                                                        <option value="status">
                                                            <fmt:message key="status"/>
                                                        </option>
                                                        <option value="started">
                                                            <fmt:message key="started.date"/>
                                                        </option>
                                                        <option value="last-active" selected>
                                                            <fmt:message key="last.active"/>
                                                        </option>
                                                    </select>
<%
        }
%>
                                                </td>
                                            </tr>
                                            <tr>
                                                <td></td>
                                                <td>
                                                    <input type="submit" name="filtersubmit" value="Filter">
                                                    <input type="reset" name="cancelsubmit" value="Cancel">
                                                </td>
                                            </tr>
                                            </tbody>
                                        </table>
                                    </td>
                                </tr>
                            </tbody>
                        </form>
                    </table>
                    <br/>
<%
    if(instanceList != null && instanceList.getInstance() != null) {
%>


                    <carbon:paginator pageNumber="<%=pageNumberInt%>" numberOfPages="<%=numberOfPages%>"
                      page="list_instances.jsp" pageNumberParameterName="pageNumber"
                      resourceBundle="org.wso2.carbon.bpel.ui.i18n.Resources"
                      prevKey="prev" nextKey="next"
                      parameters="<%= parameters%>"/>
                    <table id="instanceListTable" class="styledLeft" width="100%">
                        <thead>
                            <tr>
                                <th><nobr><fmt:message key="instance.id"/></nobr></th>
                                <th><nobr><fmt:message key="process.id"/></nobr></th>
                                <th><nobr><fmt:message key="status"/></nobr></th>
                                <th><nobr><fmt:message key="date.started"/></nobr></th>
                                <th><nobr><fmt:message key="last.active"/></nobr></th>
                                <th colspan="3"><fmt:message key="actions"/></th>
                            </tr>
                        </thead>
                        <tbody>
<%
        for(LimitedInstanceInfoType instanceInfo : instanceList.getInstance()) {
%>
                            <tr>
<%
            if(isAuthenticatedForInstanceManagement) {
%>
                                <td><a href="instance_view.jsp?iid=<%=instanceInfo.getIid()%>"><%=instanceInfo.getIid()%></a></td>
<%
            } else {
%>
                                <td><%=instanceInfo.getIid()%></td>
<%
            }

            if(isAuthenticatedForProcessManagement) {
%>
                                <td><a href="process_info.jsp?Pid=<%=instanceInfo.getPid()%>"><%=instanceInfo.getPid()%></a></td>
<%
            } else {
%>
                                <td><%=instanceInfo.getPid()%></td>
<%
            }
%>
                                <td><%=instanceInfo.getStatus()%></td>
                                <td><%=instanceInfo.getDateStarted().getTime().toString()%></td>
                                <td><%=instanceInfo.getDateLastActive().getTime().toString()%></td>
<%
            if(isAuthenticatedForInstanceManagement) {
%>
                <%=BpelUIUtil.getInstanceOperations(instanceInfo.getStatus(), instanceInfo.getIid())%>
<%
            } else {
%>
                                    &nbsp;
<%
            }
%>
                            </tr>
<%
        }
%>
                        </tbody>
                    </table>
                    <carbon:paginator pageNumber="<%=pageNumberInt%>" numberOfPages="<%=numberOfPages%>"
                      page="list_instances.jsp" pageNumberParameterName="pageNumber"
                      resourceBundle="org.wso2.carbon.bpel.ui.i18n.Resources"
                      prevKey="prev" nextKey="next"
                      parameters="<%= parameters%>"/>
<%
    } else {
%>
                    <p>No process instances found.</p>
<%
    }
%>
                </div>
            </div>
        </div>
    </div>
</fmt:bundle>