<!--
 ~ Copyright (c) 2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 ~
 ~ WSO2 Inc. licenses this file to you under the Apache License,
 ~ Version 2.0 (the "License"); you may not use this file except
 ~ in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~    http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing,
 ~ software distributed under the License is distributed on an
 ~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 ~ KIND, either express or implied.  See the License for the
 ~ specific language governing permissions and limitations
 ~ under the License.
 -->
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="javax.xml.namespace.QName" %>
<%@ page import="org.wso2.carbon.bpel.ui.clients.ProcessManagementServiceClient" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="org.wso2.carbon.bpel.mgt.ui.types.EndpointRef_type0" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.bpel.ui.BpelUIUtil" %>
<%@ page import="java.util.TreeMap" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>

<%
    response.setHeader("Cache-Control", "no-cache");
    String processServiceName = request.getParameter("processServiceName");
    String processID = request.getParameter("processID");

    String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);

    ProcessManagementServiceClient processMgtClient;
    processMgtClient = new ProcessManagementServiceClient(cookie, backendServerURL, configContext);

    TreeMap<String, QName> refMap = BpelUIUtil.getEndpointRefsMap(processMgtClient.getProcessInfo(QName.valueOf(processID)));
%>

<fmt:bundle basename="org.wso2.carbon.bpel.ui.i18n.Resources">
<table class="styledLeft" id="serviceOperationsParentTable" style="margin-left: 0px;" width="100%">
    <thead>
        <tr>
            <th colspan="2" align="left"><fmt:message key="quality.of.service.configuration"/></th>
        </tr>
    </thead>
    <tr>
        <td colspan="2">
            <span class="icon-text" style="background-image:url(../service-mgt/images/service.gif);"><fmt:message key="partnerlinks"/>&nbsp;&nbsp;</span>
            <select id="partnerLinkSelector" onclick="changepartnerLinkValue()" onchange="changepartnerLinkValue()" style="margin-top:2px !important;">
<%
    boolean isFirst=true;                 //this is due to an assumption of first element of EPRMap is the process itself
    for(String partnerLink : refMap.keySet()) {
        if(!isFirst) {
%>
                            <option value="<%= partnerLink%>"><%= partnerLink%></option>
<%
        } else {
            isFirst=false;
%>
                            <option value="<%= partnerLink%>" selected="true"><%= partnerLink%></option>
                            <script type="text/javascript">
                                jQuery(document).ready(function() {
                                    changepartnerLinkValue();
                                });
                            </script>
<%
        }
    }
%>
            </select>

            <script type="text/javascript">
                jQuery.noConflict();
                function changepartnerLinkValue() {
                    var state = document.getElementById('partnerLinkSelector').value;
                    var url = 'process_qos_ajaxprocessor.jsp?processID=<%= processID%>&partnerLink=' + state;
                    jQuery("#qos_frame").load(url, null, function (responseText, status, XMLHttpRequest) {
                        if (status != "success") {
                            CARBON.showErrorDialog('<fmt:message key="could.not.get.service.for.partnerlink"/>');
                        }
                    });
                }
            </script>
        </td>
    </tr>

    <tr>
        <td colspan="2">
            <div id="qos_frame"></div>  <!--TODO: Avoiding the table-->
        </td>
    </tr>
</table>
</fmt:bundle>